    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
//
//  Libtiff: Copyright (c) 1988-1997 Sam Leffler
//           Copyright (c) 1991-1997 Silicon Graphics, Inc.
/
                            //////////////////////////////////////////*/
#include <string>
#include <iostream>
using namespace std;
#include "o3image.h"
#include "o3server.h"

int main(int argc, char *argv[])
{
	string in, out, configfile;

	bool streamin = false, streamout = false;
	bool gotin = false, gotout = false;
	bool nextiscfg = false;
	string tmp;
	int a;

	for (a = 1; a < argc; ++a) {
		tmp = argv[a];

		if (tmp.find("-i") == 0) {
			in = "<stdin>";
			streamin = true;
			gotin = true;
		} else if (tmp.find("-o") == 0) {
			out = "<stdout>";
			streamout = true;
			gotout = true;
		} else if (tmp.find("-c") == 0) {
			nextiscfg = true;
		} else {
			if (nextiscfg) {
				configfile = tmp;
				nextiscfg = false;
			} else if (!gotin) {
				in.assign(argv[a]);
				gotin = true;
			} else if (!gotout) {
				out.assign(argv[a]);
				gotout = true;
			}
		}
	}

	if (!gotin || !gotout) {	//if (argc < 3) {
		cout << "    /////'\n"
			 << " ./%'\n"
			 << ",/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||\n"
			 << "%/    adAHY\"'\"YHAbn\n"
			 << "//  .dHY\"'     '\"YHb.\n"
			 << "//  dHY'         'YHb                       ___     ___\n"
			 << "//  HH1           1HH                      /  /    /__/     /\n"
			 << "//  HH1           1HH  .d888b.            /__/pen /repress /nterface\n"
			 << "//  9Hb.         .dHP  887\"88b\n"
			 << "//  'VHAn.     .aAHA'   \"  ;88\n"
			 << "//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b\n"
			 << "//     '\"YTHHHTY\"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8\n"
			 << "//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8\n"
			 << "//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8\n"
			 << "//                     '98887'        o888888 '5880 8    'V'  '5880 8\n"
			 << "//\n"
			 << "//  - THE Open Source Open Prepress Interface Server ----- ---- --- -- -\n"
			 << "//  Copyright (c) 2k++ - 2k.2 ebios Informationssysteme, Volker Birk\n"
			 << "//  Version 0.42, coded by Marcus 'M++' Warga (mwarga@ebios.de)\n"
                         << "//                   patched by Steffen Burmeister (sb@ebios.de)\n"
			 << "//  Currently available for Windows, Linux, DOS and HP-UX systems.\n"
			 << "//  check out http://opi3.ebios.de or mailto:opi3@ebios.de\n"
			 << "//  Libtiff: Copyright (c) 1988-1997 Sam Leffler\n"
			 << "//           Copyright (c) 1991-1997 Silicon Graphics, Inc.\n"
			 << "//\n"
			 << "//  usage: opi3 in.ps out.ps\n"
			 << "//         opi3 -i out.ps < instream\n"
			 << "//         opi3 -o in.ps > outstream\n"
			 << "//         opi3 -i -o < instream > outstream\n"
			 << "//\n"
			 << "//  optional:   -c configfile.cfg\n"
			 << "//\n"
			 << " ERROR:                     ////////////////////////////////////////////\n";
		
		if (!gotin)
			cout << " - no input\n";
		if (!gotout)
			cout << " - no output\n";
		exit(1337);
	}

	if (!streamout) {
		cout << "- OPI3 - THE Open Source Open Prepress Interface Server --- -- -\n"
			 << "Copyright (c) 2k++ - 2k.2 ebios Informationssysteme, Volker Birk\n"
			 << "Version 0.42, coded by Marcus 'M++' Warga (mwarga@ebios.de)\n"
			 << "Currently available for Windows, Linux, DOS and HP-UX systems.\n"
			 << "check out http://opi3.ebios.de or mailto:opi3@ebios.de\n"
			 << "Libtiff: Copyright (c) 1988-1997 Sam Leffler\n"
			 << "         Copyright (c) 1991-1997 Silicon Graphics, Inc.\n";
	}
	
	OPIServer::init(configfile);
	OPIServer::parse(in, out, streamin, streamout);
	OPIServer::shutdown();

	return 0;
}
