    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <new>
using namespace std;
#include "o3opiheader.h"
#include "o3exceptions.h"

OPIHeader::OPIHeader()
{

}

HeaderItem *OPIHeader::headerItem(OPIHeader::HI_ID hiid)
{
	switch (hiid) {
		case HI_aldimagefilename:		return &aldimagefilename;
		case HI_aldimageid:				return &aldimageid;
		case HI_aldobjectcomments:		return &aldobjectcomments;
		case HI_aldimagedimensions:		return &aldimagedimensions;
		case HI_aldimagecroprect:		return &aldimagecroprect;
		case HI_aldimagecropfixed:		return &aldimagecropfixed;
		case HI_aldimageposition:		return &aldimageposition;
		case HI_aldimageresolution:		return &aldimageresolution;
		case HI_aldimagecolortype:		return &aldimagecolortype;
		case HI_aldimagecolor:			return &aldimagecolor;
		case HI_aldimagetint:			return &aldimagetint;
		case HI_aldimageoverprint:		return &aldimageoverprint;
		case HI_aldimagetype:			return &aldimagetype;
		case HI_aldimagegraymap:		return &aldimagegraymap;
		case HI_aldimagetransparency:	return &aldimagetransparency;
		case HI_beginobject:			return &beginobject;
		case HI_imageoperands:			return &imageoperands;
 
		case HI_beginopi:				return &beginopi;
		case HI_distilled:				return &distilled;
		case HI_imagefilename:			return &imagefilename;
		case HI_mainimage:				return &mainimage;
		case HI_imagedimensions:		return &imagedimensions;
		case HI_imagecroprect:			return &imagecroprect;
		case HI_imageoverprint:			return &imageoverprint;
		case HI_imageinks:				return &imageinks;
		case HI_graphicsstate:			return &graphicsstate;
		case HI_beginincludedimage:		return &beginincludedimage;
		case HI_includedimagedimensions:return &includedimagedimensions;
		case HI_includedimagetype:		return &includedimagetype;
		case HI_includedimagequality:	return &includedimagequality;
 
		case HI_beginbinary:			return &beginbinary;
		case HI_begindata:				return &begindata;

		default:						return NULL;
	};
}

map<int, HeaderItem> *OPIHeader::headerItemMap(HIM_ID himid)
{
	switch (himid) {
		case HIM_aldimageasciitags:		return &aldimageasciitags;
		case HIM_tiffasciitags:			return &tiffasciitags;
		default:						return NULL;
	}
}

OPIHeader *OPIHeader::clone()
{
	OPIHeader *newheader;
	
	try {
		newheader = new OPIHeader();
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	newheader->headerItem(HI_aldimagecolor)->clone(aldimagecolor);
	newheader->headerItem(HI_aldimagecolortype)->clone(aldimagecolortype);
	newheader->headerItem(HI_aldimagecropfixed)->clone(aldimagecropfixed);
	newheader->headerItem(HI_aldimagecroprect)->clone(aldimagecroprect);
	newheader->headerItem(HI_aldimagedimensions)->clone(aldimagedimensions);
	newheader->headerItem(HI_aldimagefilename)->clone(aldimagefilename);
	newheader->headerItem(HI_aldimagegraymap)->clone(aldimagegraymap);
	newheader->headerItem(HI_aldimageid)->clone(aldimageid);
	newheader->headerItem(HI_aldimageoverprint)->clone(aldimageoverprint);
	newheader->headerItem(HI_aldimageposition)->clone(aldimageposition);
	newheader->headerItem(HI_aldimageresolution)->clone(aldimageresolution);
	newheader->headerItem(HI_aldimagetint)->clone(aldimagetint);
	newheader->headerItem(HI_aldimagetransparency)->clone(aldimagetransparency);
	newheader->headerItem(HI_aldimagetype)->clone(aldimagetype);
	newheader->headerItem(HI_aldobjectcomments)->clone(aldobjectcomments);
	newheader->headerItem(HI_beginbinary)->clone(beginbinary);
	newheader->headerItem(HI_begindata)->clone(begindata);
	newheader->headerItem(HI_beginincludedimage)->clone(beginincludedimage);
	newheader->headerItem(HI_beginobject)->clone(beginobject);
	newheader->headerItem(HI_beginopi)->clone(beginopi);
	newheader->headerItem(HI_distilled)->clone(distilled);
	newheader->headerItem(HI_graphicsstate)->clone(graphicsstate);
	newheader->headerItem(HI_imagecroprect)->clone(imagecroprect);
	newheader->headerItem(HI_imagedimensions)->clone(imagedimensions);
	newheader->headerItem(HI_imagefilename)->clone(imagefilename);
	newheader->headerItem(HI_imageinks)->clone(imageinks);
	newheader->headerItem(HI_imageoperands)->clone(imageoperands);
	newheader->headerItem(HI_imageoverprint)->clone(imageoverprint);
	newheader->headerItem(HI_includedimagedimensions)->clone(includedimagedimensions);
	newheader->headerItem(HI_includedimagequality)->clone(includedimagequality);
	newheader->headerItem(HI_includedimagetype)->clone(includedimagetype);
	newheader->headerItem(HI_mainimage)->clone(mainimage);

//	aldimageasciitag
//	tiffasciitag

	map<int, HeaderItem>::iterator i;

	for (i = tiffasciitags.begin(); i != tiffasciitags.end(); i++) {
//		newheader->headerItemMap(HIM_tiffasciitags)->insert(map<int, HeaderItem>::value_type(i->first, 0));
		(*newheader->headerItemMap(HIM_tiffasciitags))[i->first] = 0;
		(*newheader->headerItemMap(HIM_tiffasciitags))[i->first].clone(i->second);
	}

	for (i = aldimageasciitags.begin(); i != aldimageasciitags.end(); i++) {
//		newheader->headerItemMap(OPIHeader::HIM_aldimageasciitags)->insert(map<int, HeaderItem>::value_type(i->first, 0));
		(*newheader->headerItemMap(OPIHeader::HIM_aldimageasciitags))[i->first] = 0;
		(*newheader->headerItemMap(OPIHeader::HIM_aldimageasciitags))[i->first].clone(i->second);
	}

	return newheader;
}
