    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <iostream>
#include <string>
#include <map>
#include <stdlib.h>
using namespace std;
#include "o3image.h"
#include "o3settings.h"
#include "o3literals.h"
#include "o3path3mapper.h"
#include "o3exceptions.h"
#include "o3log.h"

Settings *settings;
/*
#ifndef _MSC_VER
void strlwr(char *str)
{
	unsigned a, b;

	b = strlen(str);
	for (a = 0; a < b; ++a) {
		*str = tolower(*str);
		++str;
	}
}
#endif
*/

#ifndef _MSC_VER
extern void strlwr(char *str);
#endif

Settings::Settings(string &configfile)
{
	linesepchars[0] = Literals::CR;
	linesepchars[1] = Literals::LF;
	linesepchars[2] = 0;  // asciiz-string
	lineseplen = 2;
	linesep = eCRLF;

	outputformat = Image::eOPI20;

//	logfilename = "/usr/src/opi3-gen/opi3-0.2/log.txt";
	logfilename = "opi3log.txt";
        findscript = "findscript.sh";
        errorimg = "o3noimage.tif";
	logtoscreen = true;
	//casesensitive = false;
	forcereplace = false;
	dataformat = eHex;
	replace = eAuto;

	if (configfile.empty())
		configfile.assign("opi3.cfg");

//	cout << "using configfile " << configfile << "\n";

	open(configfile.c_str(), ios::in);
	if (!fail()) {
		readSettings();
		close();
	} else
		throw ExceptionConfigOpenFailed(configfile);
}

void Settings::readSettings()
{
	string id, value, line, hires;
	char buf[300]; // a cfg-line can be max 300 bytes (incl nullterm)
	unsigned a, b;
/*	map<string, string> tmppaths;

	hires = "\\"; */
	id = "";
	seekg(0);

	while (eof() == false) {
		getline(buf, 300, '\n');

		if (buf[strlen(buf)-1] == 13)
			buf[strlen(buf)-1] = 0;	
	
		line.assign(buf);
		line = killComment(line);
		
		for (a = 0, b = line.length(); a < b; ++a)		// skip empty lines..
			if (line.at(a) != 32 && line.at(a) != 10 && line.at(a) != 13)
				break;
		if (a >= b)
			continue;


		id = gettoken(line, Literals::Settings::KeyValDelim, 0);
		value = gettoken(line, Literals::Settings::KeyValDelim, 1);

		if (CMP(id, Literals::Settings::Keys::ForceReplace)) {
			if (CMP(value, Literals::Settings::Values::True))
				forcereplace = true;
			else forcereplace = false;
		} else if (CMP(id, Literals::Settings::Keys::Data)) {
			if (CMP(value, Literals::Settings::Values::Bin))
				dataformat = eBin;
			else dataformat = eHex;
		} else if (CMP(id, Literals::Settings::Keys::HiResPath)) {
			/*if (!value.length())
				hires = "//";		// see o3server.cpp::searchImage(...)
			else*/
				hires = value;	// fuer darauf folgende lores eintraege speichern
		} else if (CMP(id, Literals::Settings::Keys::LoResPath)) {
			/*tmppaths[value] = hires; // .insert(map<string, string>::value_type(, hires)); */
			path3mapper->addMapping(value, hires);

		} else if (CMP(id, Literals::Settings::Keys::Log)) {
			logfilename = value;
                } else if (CMP(id, Literals::Settings::Keys::FindScript)) {
                        findscript = value;
                } else if (CMP(id, Literals::Settings::Keys::ErrorImage)) {
                        errorimg = value;
		} else if (CMP(id, Literals::Settings::Keys::LogToScreen)) {
			if (CMP(value, Literals::Settings::Values::True))
				logtoscreen = true;
			else if (CMP(value, Literals::Settings::Values::False))
				logtoscreen = false;

		} else if (CMP(id, Literals::Settings::Keys::Output)) {
			if (CMP(value, Literals::Settings::Values::OPI13))
				outputformat = Image::eOPI13;

			else if (CMP(value, Literals::Settings::Values::OPI20))
				outputformat = Image::eOPI20;

			else if (CMP(value, Literals::Settings::Values::OPIMixed))
				outputformat = Image::eOPIMixed;

			else
				cout << Literals::Settings::UnknownOutput + "\n";

		} else if (CMP(id, Literals::Settings::Keys::LineSep)) {
			if (CMP(value, Literals::Settings::Values::CR)) {
				lineseplen = 1;
				linesepchars[0] = Literals::CR;
				linesepchars[1] = 0;
				linesep = eCR;

			} else if (CMP(value, Literals::Settings::Values::LF)) {
				lineseplen = 1;
				linesepchars[0] = Literals::LF;
				linesepchars[1] = 0;
				linesep = eLF;

			} else if (CMP(value, Literals::Settings::Values::CRLF)) {
				lineseplen = 2;
				linesepchars[0] = Literals::CR;
				linesepchars[1] = Literals::LF;
				linesepchars[2] = 0;
				linesep = eCRLF;

			} else if (CMP(value, Literals::Settings::Values::LFCR)) {
				lineseplen = 2;
				linesepchars[0] = Literals::LF;
				linesepchars[1] = Literals::CR;
				linesepchars[2] = 0;
				linesep = eLFCR;

			} else
				cout << Literals::Settings::UnknownLineSep + "\n";

		} else if (CMP(id, Literals::Settings::Keys::Replace)) {
			if (CMP(value, Literals::Settings::Values::Auto))
				replace = eAuto;

			else if (CMP(value, Literals::Settings::Values::Manual))
				replace = eManual;

			else
				cout << Literals::Settings::UnknownReplace << "\n";

		} else if (id.length() > 0)
			cout << Literals::Settings::UnknownSetting+id << "\n";
	}

/* weg mit dem scheiss...
	map<string, string>::iterator i;
	if (!casesensitive) {
		char tmp[2048];

		for (i = tmppaths.begin(); i != tmppaths.end(); i++) {
			i->first.copy(tmp, i->first.length(), 0);
			tmp[i->first.length()] = 0;
			strlwr(tmp);
			paths[tmp] = i->second;		
		}
	} else
		for (i = tmppaths.begin(); i != tmppaths.end(); i++)
			paths[i->first] = i->second;
*/
}

string Settings::killComment(const string& str)
{
	string ret;
	int a;

	ret = gettoken(str, Literals::Settings::CommentDelim, 0);
	if (ret.length() < str.length()) { // there was a comment.. spaces between the last word
									  //  and # must be cut off..
		a = ret.find_last_not_of(' ', ret.length());
		if (a != string::npos)
			ret.resize(a+1);
	}

	return ret;
}

string Settings::gettoken(const string& str, const char *delim, int index)
{
	int a,b,x,delimlen;
	string n;

	delimlen = strlen(delim);
	n.assign("");

	a = 0;
	b = str.find(delim,0);

	for (x = 0; x < index; x++) {
		if (b == string::npos)
			return n;

		a = b+delimlen;
		b = str.find(delim,a);
	}

	if (b == string::npos)
		b = str.length();

	return str.substr(a, b-a);
}

string Settings::gettoken(const string& str, const char delim, int index)
{
	int a,b,x;
	string n;

	n.assign("");

	a = 0;
	b = str.find(delim,0);

	for (x = 0; x < index; x++) {
		if (b == string::npos)
			return n;

		a = b+1;
		b = str.find(delim,a);
	}

	if (b == string::npos)
		b = str.length();

	return str.substr(a, b-a);
}

inline bool Settings::CMP(const string& str1, const char *str2)
{
#ifdef _MSC_VER

	if (!stricmp(str1.c_str(), str2))
		return true;
	else 
		return false;

#else

	if (!strcasecmp(str1.c_str(), str2))
		return true;
	else
		return false;

#endif
}

inline bool Settings::CMP(const string& str1, const string& str2)
{
#ifdef _MSC_VER

	if (!stricmp(str1.c_str(), str2.c_str()))
		return true;
	else
		return false;

#else

	if (!strcasecmp(str1.c_str(), str2.c_str()))
		return true;
	else
		return false;

#endif
}

Settings::ReplaceMode Settings::getReplaceMode() const
{
	return replace;
}

int Settings::getLineSepLen() const
{
	return lineseplen;
}

char const* Settings::getLineSep() const
{
	return linesepchars;
}

Image::OPIVersion Settings::getOutputFormat() const
{
	return outputformat;
}
